package app;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import wfe.Keyboard;
import wfe.Mouse;
import wfe.game.GameManagerScreen;
import wfe.game.screen.Screen;
import wfe.util.SM;

/**
 * @author Death
 */
public class GameScreen extends Screen{

    int r = 10;
    Color colorOval = new Color(255, 0, 0);
    BufferedImage image;
    int x , y;
    
    @Override
    public void init(GameManagerScreen game){
        image = SM.imgFile("./img.png");//Загружаем файл
    }

    @Override
    public void paint(Graphics2D g){
        g.setColor(colorOval);
        g.fillOval(Mouse.x - r, Mouse.y - r, r * 2, r * 2);//Рисуем
        g.drawImage(image, x, y, null);
    }

    @Override
    public void update(){
    }

    @Override
    public boolean lstKey(int key, int type){
        //Обрабока нажатия и удерживание клавиши клавиатуры
        if(type == Keyboard.PRESSED){
            int speed = 2;
            switch(key){
                case KeyEvent.VK_W: y -= speed; break;
                case KeyEvent.VK_S: y += speed; break;
                case KeyEvent.VK_D: x += speed; break;
                case KeyEvent.VK_A: x -= speed; break;
            }
        }else if(type == Keyboard.RELEASED){
            //Отпускание клавиши
            return true;
        }
        return false;
    }

    @Override
    public boolean lstMouse(int key, int type){
        if(type == Mouse.PRESSED){
            //ЛКМ
            if(key == MouseEvent.BUTTON1) colorOval = SM.setR(colorOval, SM.random(0, 255));
            //ПКМ
            if(key == MouseEvent.BUTTON3) colorOval = SM.setG(colorOval, SM.random(0, 255));
        }else if(type == Mouse.RELEASED){
            //Отпускани КМ
            return true;
        }
        
        //Обработка колесика мыши
        if(type == Mouse.WHEEL){
            if(key == Mouse.UP){
                r += 1;
                if(r > 30) r = 30;
            }
            if(key == Mouse.DOWN){
                r -= 1;
                if(r < 5) r = 5;
            }
            return true;
        }
        return false;
    }

}
